Index: cards/delphes_card_IDEA.tcl
===================================================================
--- cards/delphes_card_IDEA.tcl	(revision f8e61b2e475830f7ad0431bfc7a091d9db9932c4)
+++ cards/delphes_card_IDEA.tcl	(revision db316cdc89aa1665654e96ccd339da2f35cb227f)
@@ -68,7 +68,4 @@
   TauTagging
 
-  UniqueObjectFinder
-
-  ScalarHT
   TreeWriter
 }
@@ -80,5 +77,5 @@
 module TruthVertexFinder TruthVertexFinder {
 
-  ## below this distance two vertices are assumed to be the same
+  ## below this distance two vertices are assumed to be merged
   set Resolution 1E-06
 
@@ -116,11 +113,13 @@
     set InputArray ParticlePropagator/chargedHadrons
     set OutputArray chargedHadrons
+    set UseMomentumVector true
+
     # We use only one efficiency, we set only 0 effincency out of eta bounds:
 
     set EfficiencyFormula {
         (abs(eta) > 3.0)                                       * (0.000) +
-        (energy >= 0.5) * (abs(eta) <= 3.0)                    * (0.997) +
-        (energy < 0.5 && energy >= 0.3) * (abs(eta) <= 3.0)    * (0.65) +
-        (energy < 0.3) * (abs(eta) <= 3.0)                     * (0.06)
+        (pt >= 0.5) * (abs(eta) <= 3.0)                    * (0.997) +
+        (pt < 0.5 && pt >= 0.3) * (abs(eta) <= 3.0)    * (0.65) +
+        (pt < 0.3) * (abs(eta) <= 3.0)                     * (0.06)
     }
 }
@@ -135,12 +134,12 @@
     set InputArray ParticlePropagator/electrons
     set OutputArray electrons
-
+    set UseMomentumVector true
 
     # Current full simulation with CLICdet provides for electrons:
     set EfficiencyFormula {
         (abs(eta) > 3.0)                                       * (0.000) +
-        (energy >= 0.5) * (abs(eta) <= 3.0)                    * (0.997) +
-        (energy < 0.5 && energy >= 0.3) * (abs(eta) <= 3.0)    * (0.65) +
-        (energy < 0.3) * (abs(eta) <= 3.0)                     * (0.06)
+        (pt >= 0.5) * (abs(eta) <= 3.0)                    * (0.997) +
+        (pt < 0.5 && pt >= 0.3) * (abs(eta) <= 3.0)    * (0.65) +
+        (pt < 0.3) * (abs(eta) <= 3.0)                     * (0.06)
     }
 }
@@ -154,11 +153,12 @@
     set InputArray ParticlePropagator/muons
     set OutputArray muons
+    set UseMomentumVector true
 
     # Current full simulation with CLICdet provides for muons:
     set EfficiencyFormula {
         (abs(eta) > 3.0)                                       * (0.000) +
-        (energy >= 0.5) * (abs(eta) <= 3.0)                    * (0.997) +
-        (energy < 0.5 && energy >= 0.3) * (abs(eta) <= 3.0)    * (0.65) +
-        (energy < 0.3) * (abs(eta) <= 3.0)                     * (0.06)
+        (pt >= 0.5) * (abs(eta) <= 3.0)                    * (0.997) +
+        (pt < 0.5 && pt >= 0.3) * (abs(eta) <= 3.0)    * (0.65) +
+        (pt < 0.3) * (abs(eta) <= 3.0)                     * (0.06)
     }
 }
@@ -417,10 +417,9 @@
 
   # 0: assume vertex time tV from MC Truth (ideal case)
-  # 1: assume vertex time tV=0
+  # 1: assume vertex time tV = 0
   # 2: calculate vertex time as vertex TOF, assuming tPV=0
+
   set VertexTimeMode 2
-
-}
-
+}
 
 ##############
@@ -721,11 +720,11 @@
 module FastJetFinder GenJetFinder {
   set InputArray NeutrinoFilter/filteredParticles
-
   set OutputArray jets
 
-  # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
-  set JetAlgorithm 6
-  set ParameterR 0.4
+  set JetAlgorithm 10
+  set ParameterR 1.5
+  set ParameterP -1.0
   set JetPTMin 1.0
+
 }
 
@@ -752,7 +751,10 @@
 
   # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
-  set JetAlgorithm 6
-  set ParameterR 0.4
+  set JetAlgorithm 10
+  set ParameterR 1.5
+  set ParameterP -1.0
   set JetPTMin 1.0
+
+
 }
 
@@ -766,5 +768,5 @@
 
   # scale formula for jets
-  set ScaleFormula {1.08}
+  set ScaleFormula {1.00}
 }
 
@@ -826,19 +828,4 @@
 
 
-#####################################################
-# Find uniquely identified photons/electrons/tau/jets
-#####################################################
-
-module UniqueObjectFinder UniqueObjectFinder {
-
-  set UseUniqueID true
-# earlier arrays take precedence over later ones
-# add InputArray InputArray OutputArray
-  add InputArray PhotonIsolation/photons photons
-  add InputArray ElectronIsolation/electrons electrons
-  add InputArray MuonIsolation/muons muons
-  add InputArray JetEnergyScale/jets jets
-}
-
 
 ##################
@@ -854,4 +841,5 @@
 
     add Branch Delphes/allParticles Particle GenParticle
+    add Branch TruthVertexFinder/vertices GenVertex Vertex
 
     add Branch TrackMerger/tracks Track Track
@@ -862,4 +850,6 @@
     add Branch Calorimeter/eflowNeutralHadrons EFlowNeutralHadron Tower
 
+    add Branch EFlowMerger/eflow ParticleFlowCandidate ParticleFlowCandidate
+
     add Branch Calorimeter/photons CaloPhoton Photon
     add Branch PhotonEfficiency/photons PhotonEff Photon
@@ -869,13 +859,10 @@
     add Branch GenMissingET/momentum GenMissingET MissingET
 
-    add Branch UniqueObjectFinder/jets Jet Jet
-    add Branch UniqueObjectFinder/electrons Electron Electron
-    add Branch UniqueObjectFinder/photons Photon Photon
-    add Branch UniqueObjectFinder/muons Muon Muon
-
-    add Branch JetEnergyScale/jets AntiKtJet Jet
+    add Branch JetEnergyScale/jets Jet Jet
+    add Branch ElectronIsolation/electrons Electron Electron
+    add Branch PhotonIsolation/photons Photon Photon
+    add Branch MuonIsolation/muons Muon Muon
 
     add Branch MissingET/momentum MissingET MissingET
-    add Branch ScalarHT/energy ScalarHT ScalarHT
 
     # add Info InfoName InfoValue
Index: modules/TimeOfFlight.cc
===================================================================
--- modules/TimeOfFlight.cc	(revision f8e61b2e475830f7ad0431bfc7a091d9db9932c4)
+++ modules/TimeOfFlight.cc	(revision db316cdc89aa1665654e96ccd339da2f35cb227f)
@@ -164,7 +164,4 @@
   	}
 
-
-    //ti = ti - t_truth;
-
     p = candidateMomentum.P();
 
@@ -190,6 +187,6 @@
     candidate->InitialPosition.SetT(ti * 1.0E3 * c_light);
 
-    // update particle mass based on TOF-based PID
-    candidate->Momentum.SetVectM(candidateMomentum.Vect(), mass);
+    // update particle mass based on TOF-based PID (commented for now, assume this calculation is done offline)
+    //candidate->Momentum.SetVectM(candidateMomentum.Vect(), mass);
 
     candidate->AddCandidate(mother);
Index: modules/TimeSmearing.cc
===================================================================
--- modules/TimeSmearing.cc	(revision f8e61b2e475830f7ad0431bfc7a091d9db9932c4)
+++ modules/TimeSmearing.cc	(revision db316cdc89aa1665654e96ccd339da2f35cb227f)
@@ -103,5 +103,5 @@
   while((candidate = static_cast<Candidate *>(fItTrackInputArray->Next())))
   {
-    // converting to meters
+
     const TLorentzVector &candidateFinalPosition = candidate->Position;
     const TLorentzVector &candidateMomentum = candidate->Momentum;
